package org.mandarax.util.resultsetfilters;

/*
 * Copyright (C) 1999-2004 <a href="mailto:mandarax@jbdietrich.com">Jens Dietrich</a>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import org.mandarax.kernel.*;

/**
 * Simple result implementation used in cached result sets.
 * @author <A HREF="mailto:mandarax@jbdietrich.com">Jens Dietrich</A>
 * @version 3.3.1 <9 August 2004>
 * @since 3.0
 */
class ResultImpl extends Result {
	/**
	 * Constructor.
	 * @param d a derivation
	 * @param r an array of replacements
	 */
	ResultImpl(Derivation d, Replacement[] r) {
		super(d, r);
	}
	/**
	 * Constructor.
	 * @param r an array of replacements
	 */
	ResultImpl(Replacement[] r) {
		super(null, r);
	}
	/**
	 * Constructor.
	 * @param rs a result set
	 */
	ResultImpl(ResultSet rs) throws InferenceException {
		super(rs);		
	}
	/**
	 * Compares objects.
	 * @param o an object
	 * @return a boolean
	 */
	public boolean equals(Object o) {
		if (o != null && o instanceof ResultImpl) {
			ResultImpl r = (ResultImpl) o;
			Replacement[] replacements = getReplacements();
			if (replacements == null)
				return r.getReplacements() == null;

			for (int i = 0; i < replacements.length; i++) {
				if (!replacements[i].equals(r.getReplacements()[i]))
					return false;
			}
			return true;
		} else
			return false;
	}
	/**
	 * Get the hash code for this object.
	 * @return an integer
	 */
	public int hashCode() {
		int hc = 0;
		Replacement[] replacements = getReplacements();
		if (replacements == null)
			return hc;
		for (int i = 0; i < replacements.length; i++)
			hc = hc ^ replacements[i].hashCode();
		return hc;
	}
}
